/***************************************************************************
                          kpref.cpp  -  description
                             -------------------
    begin                : Mon Mar  6 14:43:31 EET 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kpref.h"
#include "desktop.h"
#include "deskview.h"
#include "gamer.h"

#include "qtformtorg.h"
#include "debug.h"
#include "qtnewgameu.h"
#include <time.h>
#include <qapp.h>
#include <qapplication.h>
//#include <kcharsets.h>
//#include <kprocess.h>
#include <pthread.h>

#include "resource.h"


#include "resource.h"

#include "pics/paper.xpm"
#include "pics/filesave.xpm"
#include "pics/fileopen.xpm"

#include "pics/newgame.xpm"



char *documentation; //see bottom this file
Kpref *kpref;

Kpref::Kpref() {
	setCaption("OpenPref");
	setBackgroundColor(darkGreen);
	initMenuBar();
	nflAleradyPainting = nAllReadyHinting = WaitingForMouseUp = 0;
	DeskView = NULL;
	DeskTop = NULL;
	setMouseTracking ( TRUE );
	flthread = 0;
}

void Kpref::init() {
	StatusBar1 =  new QStatusBar (this,"StatusBar1") ;
	DeskView = new TDeskView();
	DeskView -> PaintDevice = this; // &&&
//	DeskTop = new TDeskTop();
//	DeskTop -> DeskView = DeskView;
	DeskTop = new TDeskTop(DeskView);

}

Kpref::~Kpref() {
	delete StatusBar1;
	if (flthread)

	//pthread_kill(thread,SIGTERM);	

	delete Formtorg;
	delete DeskView;
	delete DeskTop;
}

void Kpref::initMenuBar()
{
		
  fileMenu=new QPopupMenu();
  fileMenu->insertItem(QPixmap(newgame_xpm),"&New game...", this, SLOT(slotNewSingleGame()), CTRL+Key_N, ID_NEWSINGLEGAME);

  fileMenu->insertSeparator();
  fileMenu->insertItem(QPixmap(fileopen),"&Open...", this, SLOT(slotFileOpen()), CTRL+Key_O, ID_FILE_OPEN);
  nSaveGameID = fileMenu->insertItem(QPixmap(filesave),"&Save", this, SLOT(slotFileSave()), CTRL+Key_S, ID_FILE_SAVE);
  fileMenu->insertSeparator();
  fileMenu->insertItem("Quit", qApp, SLOT(quit()), CTRL+Key_Q, ID_FILE_QUIT);

  fileMenu->setItemEnabled(nSaveGameID,FALSE);

  viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewMenu->insertItem(QPixmap(paper_xpm),"Score...", this, SLOT(slotShowBollet()), 0, ID_VIEW_BOLLET);

  helpMenu=new QPopupMenu();
  helpMenu->insertItem("About", this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);

  menuBar()->insertItem("&Game", fileMenu);
  menuBar()->insertItem("&Show", viewMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem("&Help", helpMenu);



}



/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void Kpref::slotFileOpen() {
  QString fileName = QFileDialog::getOpenFileName(0,"*.prf",this);
  if (!fileName.isEmpty())  {
		DeskTop->LoadGame(fileName);
		fileMenu->setItemEnabled(nSaveGameID,TRUE);
		DeskTop ->RunGame();
  }
}


void Kpref::slotFileSave() {
	if ( DeskTop ) {
		QString fn = QFileDialog::getSaveFileName(0, "*.prf", this);
		if (!fn.isEmpty())  {      // save the game
			DeskTop ->SaveGame(fn);
		}
	}
}

/*
void Kpref::slotFileQuit() {
	//quit();
}
*/


void Kpref::slotEndSleep() {
	//QEvent Event(Event_Timer);
	//qApp->postEvent(this,&Event );
}

void Kpref::slotShowBollet() {
    DeskTop->CloseBullet();
    DeskTop-> nflShowPaper = 1;
    DeskTop->ShowPaper();
    DeskTop->DeskView->mySleep(0);
    DeskView ->ClearScreen();
    DeskTop-> nflShowPaper = 0;
    DeskTop->Repaint();
}
//----------------------------------------------------

void Kpref::slotNewSingleGame() {
	qtnewgameu newgame(this,"NewSingleGame");
	if (  newgame.exec() ) {
		if (DeskTop) {
			delete DeskTop;
			delete DeskView;
			DeskView = new TDeskView();
			DeskView -> PaintDevice = this; // &&&
			DeskTop = new TDeskTop();
			DeskTop -> DeskView = DeskView;
			nBuletScore = newgame.QSpinBox_2 ->value();
			g61stalingrad =  (newgame.StalingradGame->isChecked() == true);
			g10vist = (newgame.TenVist->isChecked() == true);
			globvist = (newgame.VistNonBr->isChecked() == true);
			DeskView -> DesktopHeight = height();
			DeskView -> DesktopWidht = width();
			//DeskView->ClearScreen();
			if (newgame.flProtocol->isChecked () ) {
				strcpy(DeskTop -> ProtocolFileName,newgame.ProtocolFileName ->text() );
				DeskTop -> flProtocol = 1;
				DeskTop -> OpenProtocol();				
			}			
		}
		fileMenu->setItemEnabled(nSaveGameID,TRUE);
		DeskTop -> RunGame();
	}
}
//-----------------------------------------------------------------------------------------
void  Kpref::mouseMoveEvent ( QMouseEvent *MEvent ) {
    if ( ! nAllReadyHinting ) {
        nAllReadyHinting = 1;
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
//        Gamer ->DeskView = DeskView;
				if (Gamer) {
	        Gamer -> HintCard(MEvent->x(),MEvent->y());
	      }
        nAllReadyHinting = 0;
    }
}
//-----------------------------------------------------------------------------------------
void  Kpref::mousePressEvent ( QMouseEvent * MEvent) {
//		int nwait;
    WaitingForMouseUp = 1;
    DeskView -> Event = 1;
//    if (WaitingForMouseUp) {

//        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(1);
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
//        Gamer ->DeskView = DeskView;
				if (Gamer) {
	        Gamer -> X = MEvent->x();
  		      Gamer -> Y = MEvent->y();
  		    }
        WaitingForMouseUp = 0;
//    }
}
//-----------------------------------------------------------------------------------------
void  Kpref::keyPressEvent ( QKeyEvent * KEvent) {
	if (DeskView)
		DeskView -> Event = 1;
}
//-----------------------------------------------------------------------------------------
void Kpref::paintEvent (QPaintEvent *PaintEvent) {
		if ( !nflAleradyPainting ) {
			nflAleradyPainting = 1;
	    if ( DeskView ) {
  	      DeskView -> DesktopHeight = height();
    	    DeskView -> DesktopWidht = width();
	    }
  	  if ( DeskTop ) {
    	    DeskTop -> Repaint();
	    }
			nflAleradyPainting = 0;
		}
}
//-----------------------------------------------------------------------------------------
void Kpref::slotHelpAbout() {
  QMessageBox::about(this, "About...",  IDS_APP_ABOUT);
}

